| Flutter Impeller |

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
impeller::FilterContents Class Referenceabstract

`#include <filter_contents.h>`

Inheritance diagram for impeller::FilterContents:

## Public Types
enum class | BlurStyle { kNormal , kSolid , kOuter , kInner }
enum class | MorphType { kDilate , kErode }
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>

## Public Member Functions
| FilterContents ()
| ~FilterContents () override
void | SetInputs (FilterInput::Vector inputs)
| The input texture sources for this filter. Each input's emitted texture is expected to have premultiplied alpha colors. More...
void | SetEffectTransform (const Matrix &effect_transform)
| Sets the transform which gets appended to the effect of this filter. Note that this is in addition to the entity's transform. More...
std::optional< Entity > | GetEntity (const ContentContext &renderer, const Entity &entity, const std::optional< Rect > &coverage_hint) const
| Create an Entity that renders this filter's output. More...
bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the area of the render pass that will be affected when this contents is rendered. More...
std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, int32_t mip_count=1, std::string_view label="Filter Snapshot") const override
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
std::optional< Rect > | GetSourceCoverage (const Matrix &effect_transform, const Rect &output_limit) const
| Determines the coverage of source pixels that will be needed to produce results for the specified |output_limit| under the specified |effect_transform|. This is essentially a reverse of the |GetCoverage| method computing a source coverage from an intended |output_limit| coverage. More...
virtual Matrix | GetLocalTransform (const Matrix &parent_transform) const
Matrix | GetTransform (const Matrix &parent_transform) const
virtual void | SetRenderingMode (Entity::RenderingMode rendering_mode)
| Marks this filter chain as applying in a subpass scenario. More...
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque (const Matrix &transform) const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual void | SetInheritedOpacity (Scalar opacity)
| Inherit the provided opacity. More...
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Static Public Member Functions
static std::shared_ptr< FilterContents > | MakeGaussianBlur (const FilterInput::Ref &input, Sigma sigma_x, Sigma sigma_y, Entity::TileMode tile_mode=Entity::TileMode::kDecal, BlurStyle mask_blur_style=BlurStyle::kNormal, const Geometry *mask_geometry=nullptr)
static std::shared_ptr< FilterContents > | MakeBorderMaskBlur (FilterInput::Ref input, Sigma sigma_x, Sigma sigma_y, BlurStyle blur_style=BlurStyle::kNormal)
static std::shared_ptr< FilterContents > | MakeDirectionalMorphology (FilterInput::Ref input, Radius radius, Vector2 direction, MorphType morph_type)
static std::shared_ptr< FilterContents > | MakeMorphology (FilterInput::Ref input, Radius radius_x, Radius radius_y, MorphType morph_type)
static std::shared_ptr< FilterContents > | MakeMatrixFilter (FilterInput::Ref input, const Matrix &matrix, const SamplerDescriptor &desc)
static std::shared_ptr< FilterContents > | MakeLocalMatrixFilter (FilterInput::Ref input, const Matrix &matrix)
static std::shared_ptr< FilterContents > | MakeYUVToRGBFilter (std::shared_ptr< Texture > y_texture, std::shared_ptr< Texture > uv_texture, YUVColorSpace yuv_color_space)
static std::shared_ptr< FilterContents > | MakeRuntimeEffect (FilterInput::Ref input, std::shared_ptr< RuntimeStage > runtime_stage, std::shared_ptr< std::vector< uint8_t >> uniforms, std::vector< RuntimeEffectContents::TextureInput > texture_inputs)
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Static Public Attributes
static const int32_t | kBlurFilterRequiredMipCount

## Detailed Description

Definition at line 24 of file filter_contents.h.

## Member Enumeration Documentation

## ◆ BlurStyle

enum impeller::FilterContents::BlurStyle
| strong

Enumerator
kNormal | Blurred inside and outside.
kSolid | Solid inside, blurred outside.
kOuter | Nothing inside, blurred outside.
kInner | Blurred inside, nothing outside.

Definition at line 28 of file filter_contents.h.

28 {
29 /// Blurred inside and outside.
30 kNormal,
31 /// Solid inside, blurred outside.
32 kSolid,
33 /// Nothing inside, blurred outside.
34 kOuter,
35 /// Blurred inside, nothing outside.
36 kInner,
37 };

## ◆ MorphType

enum impeller::FilterContents::MorphType
| strong

Enumerator
kDilate |
kErode |

Definition at line 39 of file filter_contents.h.

39 { kDilate, kErode };

## Constructor & Destructor Documentation

## ◆ FilterContents()

impeller::FilterContents::FilterContents | ( |  | ) |
| default

## ◆ ~FilterContents()

impeller::FilterContents::~FilterContents | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ GetCoverage()

std::optional< Rect > impeller::FilterContents::GetCoverage | ( | const Entity & | entity | ) | const
| overridevirtual

Get the area of the render pass that will be affected when this contents is rendered.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Returns
  The coverage rectangle. An `std::nullopt` result means that rendering this contents has no effect on the output color.

Implements impeller::Contents.

Definition at line 176 of file filter_contents.cc.

176 {
177 Entity entity_with_local_transform = entity.Clone();
178 entity_with_local_transform.SetTransform(GetTransform(entity.GetTransform()));
179
180 return GetLocalCoverage(entity_with_local_transform);
181 }
impeller::FilterContents::GetTransform
Matrix GetTransform(const Matrix &parent_transform) const
Definition: filter_contents.cc:284

References impeller::Entity::Clone(), impeller::Entity::GetTransform(), GetTransform(), and impeller::Entity::SetTransform().

Referenced by Render(), and impeller::testing::TEST_P().

## ◆ GetEntity()

std::optional< Entity > impeller::FilterContents::GetEntity | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | const std::optional< Rect > & | coverage_hint
| ) |  | const

Create an Entity that renders this filter's output.

Definition at line 232 of file filter_contents.cc.

235 {
236 Entity entity_with_local_transform = entity.Clone();
237 entity_with_local_transform.SetTransform(GetTransform(entity.GetTransform()));
238
239 std::optional<Rect> coverage = GetLocalCoverage(entity_with_local_transform);
240 if (!coverage.has_value() || coverage->IsEmpty()) {
241 return std::nullopt;
242 }
243
244 return RenderFilter(inputs_, //
245 renderer, //
246 entity_with_local_transform, //
247 effect_transform_, //
248 coverage.value(), //
249 coverage_hint //
250 );
251 }

References impeller::Entity::Clone(), impeller::Entity::GetTransform(), GetTransform(), and impeller::Entity::SetTransform().

Referenced by Render(), RenderToSnapshot(), and impeller::testing::TEST_P().

## ◆ GetLocalTransform()

Matrix impeller::FilterContents::GetLocalTransform | ( | const Matrix & | parent_transform | ) | const
| virtual

Reimplemented in impeller::LocalMatrixFilterContents.

Definition at line 280 of file filter_contents.cc.

280 {
281 return Matrix();
282 }

Referenced by GetTransform().

## ◆ GetSourceCoverage()

std::optional< Rect > impeller::FilterContents::GetSourceCoverage | ( | const Matrix & | effect_transform,
|  | const Rect & | output_limit
| ) |  | const

Determines the coverage of source pixels that will be needed to produce results for the specified |output_limit| under the specified |effect_transform|. This is essentially a reverse of the |GetCoverage| method computing a source coverage from an intended |output_limit| coverage.

Both the |output_limit| and the return value are in the transformed coordinate space, and so do not need to be transformed or inverse transformed by the |effect_transform| but individual parameters on the filter might be in the untransformed space and should be transformed by the |effect_transform| before applying them to the coverages.

The method computes a result such that if the filter is applied to a set of pixels filling the computed source coverage, it should produce an output that covers the entire specified |output_limit|.

This is useful for subpass rendering scenarios where a filter will be applied to the output of the subpass and we need to determine how large of a render target to allocate in order to collect all pixels that might affect the supplied output coverage limit. While we might end up clipping the rendering of the subpass to its destination, we want to avoid clipping out any pixels that contribute to the output limit via the filtering operation.

Returns
  The coverage bounds in the transformed space of any source pixel that may be needed to produce output for the indicated filter that covers the indicated |output_limit|.

Definition at line 210 of file filter_contents.cc.

212 {
213 auto filter_input_coverage =
214 GetFilterSourceCoverage(effect_transform_, output_limit);
215
216 if (!filter_input_coverage.has_value()) {
217 return std::nullopt;
218 }
219
220 std::optional<Rect> inputs_coverage;
221 for (const auto& input : inputs_) {
222 auto input_coverage = input->GetSourceCoverage(
223 effect_transform, filter_input_coverage.value());
224 if (!input_coverage.has_value()) {
225 return std::nullopt;
226 }
227 inputs_coverage = Rect::Union(inputs_coverage, input_coverage.value());
228 }
229 return inputs_coverage;
230 }
impeller::TRect< Scalar >::Union
constexpr TRect Union(const TRect &o) const
Definition: rect.h:517

References impeller::TRect< Scalar >::Union().

## ◆ GetTransform()

Matrix impeller::FilterContents::GetTransform | ( | const Matrix & | parent_transform | ) | const

Definition at line 284 of file filter_contents.cc.

284 {
285 return parent_transform * GetLocalTransform(parent_transform);
286 }
impeller::FilterContents::GetLocalTransform
virtual Matrix GetLocalTransform(const Matrix &parent_transform) const
Definition: filter_contents.cc:280

References GetLocalTransform().

Referenced by GetCoverage(), and GetEntity().

## ◆ MakeBorderMaskBlur()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeBorderMaskBlur | ( | FilterInput::Ref | input,
|  | Sigma | sigma_x,
|  | Sigma | sigma_y,
|  | BlurStyle | blur_style = `BlurStyle::kNormal`
| ) |  |
| static

Definition at line 50 of file filter_contents.cc.

54 {
55 auto filter = std::make_shared<BorderMaskBlurFilterContents>();
56 filter->SetInputs({std::move(input)});
57 filter->SetSigma(sigma_x, sigma_y);
58 filter->SetBlurStyle(blur_style);
59 return filter;
60 }

Referenced by impeller::testing::TEST_P().

## ◆ MakeDirectionalMorphology()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeDirectionalMorphology | ( | FilterInput::Ref | input,
|  | Radius | radius,
|  | Vector2 | direction,
|  | MorphType | morph_type
| ) |  |
| static

Definition at line 62 of file filter_contents.cc.

66 {
67 auto filter = std::make_shared<DirectionalMorphologyFilterContents>();
68 filter->SetInputs({std::move(input)});
69 filter->SetRadius(radius);
70 filter->SetDirection(direction);
71 filter->SetMorphType(morph_type);
72 return filter;
73 }

Referenced by MakeMorphology().

## ◆ MakeGaussianBlur()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeGaussianBlur | ( | const FilterInput::Ref & | input,
|  | Sigma | sigma_x,
|  | Sigma | sigma_y,
|  | Entity::TileMode | tile_mode = `Entity::TileMode::kDecal`,
|  | FilterContents::BlurStyle | mask_blur_style = `BlurStyle::kNormal`,
|  | const Geometry * | mask_geometry = `nullptr`
| ) |  |
| static

Creates a gaussian blur that operates in 2 dimensions. See also: `MakeDirectionalGaussianBlur`

Definition at line 37 of file filter_contents.cc.

43 {
44 auto blur = std::make_shared<GaussianBlurFilterContents>(
45 sigma_x.sigma, sigma_y.sigma, tile_mode, mask_blur_style, mask_geometry);
46 blur->SetInputs({input});
47 return blur;
48 }

References impeller::Sigma::sigma.

Referenced by impeller::testing::TEST_P(), and impeller::WrapInput().

## ◆ MakeLocalMatrixFilter()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeLocalMatrixFilter | ( | FilterInput::Ref | input,
|  | const Matrix & | matrix
| ) |  |
| static

Definition at line 98 of file filter_contents.cc.

100 {
101 auto filter = std::make_shared<LocalMatrixFilterContents>();
102 filter->SetInputs({std::move(input)});
103 filter->SetMatrix(matrix);
104 return filter;
105 }

Referenced by impeller::WrapInput().

## ◆ MakeMatrixFilter()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeMatrixFilter | ( | FilterInput::Ref | input,
|  | const Matrix & | matrix,
|  | const SamplerDescriptor & | desc
| ) |  |
| static

Definition at line 87 of file filter_contents.cc.

90 {
91 auto filter = std::make_shared<MatrixFilterContents>();
92 filter->SetInputs({std::move(input)});
93 filter->SetMatrix(matrix);
94 filter->SetSamplerDescriptor(desc);
95 return filter;
96 }

Referenced by impeller::testing::TEST(), and impeller::WrapInput().

## ◆ MakeMorphology()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeMorphology | ( | FilterInput::Ref | input,
|  | Radius | radius_x,
|  | Radius | radius_y,
|  | MorphType | morph_type
| ) |  |
| static

Definition at line 75 of file filter_contents.cc.

79 {
80 auto x_morphology = MakeDirectionalMorphology(std::move(input), radius_x,
81 Point(1, 0), morph_type);
82 auto y_morphology = MakeDirectionalMorphology(
83 FilterInput::Make(x_morphology), radius_y, Point(0, 1), morph_type);
84 return y_morphology;
85 }
impeller::FilterContents::MakeDirectionalMorphology
static std::shared_ptr< FilterContents > MakeDirectionalMorphology(FilterInput::Ref input, Radius radius, Vector2 direction, MorphType morph_type)
Definition: filter_contents.cc:62
impeller::FilterInput::Make
static FilterInput::Ref Make(Variant input, bool msaa_enabled=true)
Definition: filter_input.cc:19
impeller::Point
TPoint< Scalar > Point
Definition: point.h:327

References impeller::FilterInput::Make(), and MakeDirectionalMorphology().

Referenced by impeller::testing::TEST_P(), and impeller::WrapInput().

## ◆ MakeRuntimeEffect()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeRuntimeEffect | ( | FilterInput::Ref | input,
|  | std::shared_ptr< RuntimeStage > | runtime_stage,
|  | std::shared_ptr< std::vector< uint8_t >> | uniforms,
|  | std::vector< RuntimeEffectContents::TextureInput > | texture_inputs
| ) |  |
| static

Definition at line 118 of file filter_contents.cc.

122 {
123 auto filter = std::make_shared<impeller::RuntimeEffectFilterContents>();
124 filter->SetInputs({std::move(input)});
125 filter->SetRuntimeStage(std::move(runtime_stage));
126 filter->SetUniforms(std::move(uniforms));
127 filter->SetTextureInputs(std::move(texture_inputs));
128 return filter;
129 }

Referenced by impeller::WrapInput().

## ◆ MakeYUVToRGBFilter()

std::shared_ptr< FilterContents > impeller::FilterContents::MakeYUVToRGBFilter | ( | std::shared_ptr< Texture > | y_texture,
|  | std::shared_ptr< Texture > | uv_texture,
|  | YUVColorSpace | yuv_color_space
| ) |  |
| static

Definition at line 107 of file filter_contents.cc.

110 {
111 auto filter = std::make_shared<impeller::YUVToRGBFilterContents>();
112 filter->SetInputs({impeller::FilterInput::Make(y_texture),
113 impeller::FilterInput::Make(uv_texture)});
114 filter->SetYUVColorSpace(yuv_color_space);
115 return filter;
116 }

References impeller::FilterInput::Make().

Referenced by impeller::DlImageImpeller::MakeFromYUVTextures(), and impeller::testing::TEST_P().

## ◆ Render()

bool impeller::FilterContents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| overridevirtual

Implements impeller::Contents.

Definition at line 147 of file filter_contents.cc.

149 {
150 auto filter_coverage = GetCoverage(entity);
151 if (!filter_coverage.has_value()) {
152 return true;
153 }
154
155 // Run the filter.
156
157 auto maybe_entity = GetEntity(renderer, entity, GetCoverageHint());
158 if (!maybe_entity.has_value()) {
159 return true;
160 }
161 maybe_entity->SetClipDepth(entity.GetClipDepth());
162 return maybe_entity->Render(renderer, pass);
163 }
impeller::Contents::GetCoverageHint
const std::optional< Rect > & GetCoverageHint() const
Definition: contents.cc:140
impeller::FilterContents::GetEntity
std::optional< Entity > GetEntity(const ContentContext &renderer, const Entity &entity, const std::optional< Rect > &coverage_hint) const
Create an Entity that renders this filter's output.
Definition: filter_contents.cc:232
impeller::FilterContents::GetCoverage
std::optional< Rect > GetCoverage(const Entity &entity) const override
Get the area of the render pass that will be affected when this contents is rendered.
Definition: filter_contents.cc:176

References impeller::Entity::GetClipDepth(), GetCoverage(), impeller::Contents::GetCoverageHint(), and GetEntity().

## ◆ RenderToSnapshot()

std::optional< Snapshot > impeller::FilterContents::RenderToSnapshot | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | std::optional< Rect > | coverage_limit = `std::nullopt`,
|  | const std::optional< SamplerDescriptor > & | sampler_descriptor = `std::nullopt`,
|  | bool | msaa_enabled = `true`,
|  | int32_t | mip_count = `1`,
|  | std::string_view | label = `"Filter Snapshot"`
| ) |  | const
| overridevirtual

Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`.

Reimplemented from impeller::Contents.

Definition at line 253 of file filter_contents.cc.

260 {
261 // Resolve the render instruction (entity) from the filter and render it to a
262 // snapshot.
263 if (std::optional<Entity> result =
264 GetEntity(renderer, entity, coverage_limit);
265 result.has_value()) {
266 return result->GetContents()->RenderToSnapshot(
267 renderer, // renderer
268 result.value(), // entity
269 coverage_limit, // coverage_limit
270 std::nullopt, // sampler_descriptor
271 true, // msaa_enabled
272 /*mip_count=*/mip_count,
273 label // label
274 );
275 }
276
277 return std::nullopt;
278 }

References GetEntity().

## ◆ SetEffectTransform()

void impeller::FilterContents::SetEffectTransform | ( | const Matrix & | effect_transform | ) |

Sets the transform which gets appended to the effect of this filter. Note that this is in addition to the entity's transform.

This is useful for subpass rendering scenarios where it's difficult to encode the current transform of the layer into the Entity being rendered.

Definition at line 139 of file filter_contents.cc.

139 {
140 effect_transform_ = effect_transform;
141
142 for (auto& input : inputs_) {
143 input->SetEffectTransform(effect_transform);
144 }
145 }

Referenced by impeller::testing::TEST_P().

## ◆ SetInputs()

void impeller::FilterContents::SetInputs | ( | FilterInput::Vector | inputs | ) |

The input texture sources for this filter. Each input's emitted texture is expected to have premultiplied alpha colors.

The number of required or optional textures depends on the particular filter's implementation.

Definition at line 135 of file filter_contents.cc.

135 {
136 inputs_ = std::move(inputs);
137 }

Referenced by impeller::testing::TEST_P().

## ◆ SetRenderingMode()

void impeller::FilterContents::SetRenderingMode | ( | Entity::RenderingMode | rendering_mode | ) |
| virtual

Marks this filter chain as applying in a subpass scenario.

        Subpasses render in screenspace, and this setting informs filters
        that the current transform matrix of the entity is not stored
        in the Entity transform matrix. Instead, the effect transform
        is used in this case.

Reimplemented in impeller::MatrixFilterContents.

Definition at line 288 of file filter_contents.cc.

288 {
289 for (auto& input : inputs_) {
290 input->SetRenderingMode(rendering_mode);
291 }
292 }

Referenced by impeller::MatrixFilterContents::SetRenderingMode().

## Member Data Documentation

## ◆ kBlurFilterRequiredMipCount

const int32_t impeller::FilterContents::kBlurFilterRequiredMipCount
| static

Initial value:
=
GaussianBlurFilterContents::kBlurFilterRequiredMipCount
impeller::FilterContents::kBlurFilterRequiredMipCount
static const int32_t kBlurFilterRequiredMipCount
Definition: filter_contents.h:26

Definition at line 26 of file filter_contents.h.

The documentation for this class was generated from the following files:

- impeller/entity/contents/filters/filter_contents.h
- impeller/entity/contents/filters/filter_contents.cc